/*   Color Sinewave program     */
/*   By Patrick Bass            */
/*   (c) 1985, ANTIC PUBLISHING */
#include	"portab.h"
#include        "obdefs.h"
#include	"define.h"
#include	"gemdefs.h"
#include	"osbind.h"

     int	contrl[12], intin[256], ptsin[256], intout[256], ptsout[256];
     int	l_intin[20], l_ptsin[20], l_out[100];
     int	color, max_color, handle, xres, yres;
     int	i, k, iter, loop, times, dummy;
     int	sin_amplitude, cos_amplitude;
     int	sin_period, cos_period, step;
     int	key_state;

     double	number, xpoint;

     extern double	sin(), cos(), random();

main()
{
	appl_init();

	handle=graf_handle(&dummy,&dummy,&dummy,&dummy);

	for(i=0; i<10; i++)
	{
	     l_intin[i]=1;
	}
	l_intin[10]=2;

	v_opnvwk(l_intin, &handle, l_out);
	xres=l_out[0];
	yres=l_out[1];
	max_color=l_out[13];

	for ( loop=0; loop < 1; loop=loop+0)
	{
		do
		{
			color= Random() & 15;
		}
		while( color < 0 || color > max_color );

		vsl_color(handle, color);

		step=( Random() & 3 )+1;

		do
		{
			sin_amplitude=( Random() & 255 )+10;
		}
		while( sin_amplitude < 30 || sin_amplitude > (yres/2) );

		do
		{
			cos_amplitude=( Random() & 255 )+10;
		}
		while( cos_amplitude < 30 || cos_amplitude > (yres/2) );

		do
		{
			sin_period=( Random() & 127 )+10;
		}
		while( sin_period < 10 || sin_period > 100 );

		do
		{
			cos_period=( Random() & 127 )+10;
		}
		while( cos_period < 10 || cos_period > 100 );

		for(iter=1; iter<xres; iter=iter+step)
		{
			xpoint=iter;

			ptsin[0]=xpoint;
		       ptsin[1]=(sin(xpoint/sin_period)*sin_amplitude)+(yres/2);

			ptsin[2]=(xres-xpoint);
		       ptsin[3]=(cos(xpoint/cos_period)*cos_amplitude)+(yres/2);

			v_pline( handle, 2, ptsin);
		}

		do
		{
			vq_key_s( handle, &key_state );
		}
		while( key_state == 0 );

		if (key_state == 8 ) loop=2;
	}

	v_clsvwk(handle);
	appl_exit();
}
